uc    Order;
uint  Code, Range, FFNum, Cache, OutSize;
int64 Low;
uint  * Freq;
uint  Root[256][7];
uint  New[7];
uint  Group[8];
uint  Full[7][129];
uc *  TempBuf;

#define MaxGroupFreq 206
#define MaxRootFreq  186
#define MaxFreq      96
#define RangeTOP     (1<<24)

#define EOFTest()    if ((TempBuf-Out)>=Size) return 0       
#define OutTgtByte(c) ((* TempBuf++)=c)
#define InByte() (* TempBuf++) 
#define GetFreq(TotFreq) Code / (Range/= TotFreq)

#define ShiftLow()                              \
{                                               \
    if ((Low^0xFF000000)>0xFFFFFF){             \
    OutTgtByte((uc)(Cache+(Low>>32)));          \
    int c = (int)(0xFF+(Low>>32));              \
    while( FFNum ) OutTgtByte(c), FFNum--;      \
    Cache = (uint)(Low)>>24;                      \
  } else FFNum++;                               \
  Low = (uint)(Low)<<8;                           \
}

static inline void Encode(uint Freq, uint CumFreq, uint TotFreq)
{
  Low+=CumFreq*(Range/=TotFreq);
  Range*= Freq;
  while(Range<RangeTOP) {ShiftLow();Range<<=8;}
}
   

static inline void Decode(uint Freq, uint CumFreq, uint totFreq)
 {
   Code-=CumFreq*Range;
   Range*=Freq;
   while(Range<RangeTOP) {Code=(Code<<8)|InByte();Range<<=8;}
 }

void InitModel(void)
{
  sint  i,s=2;
  Order=0;OutSize=0;
  Low=FFNum=Cache=0;
  Range=(uint)-1;
  for (i=0;i<7;i++) New[i]=0;
  for (i=0;i<256;i++)
  {
    sint  j;
    for (j=0;j<6;j++) Root[i][j]=1;
    Root[i][6]=6;
  }
  for (i=0;i<7;i++) Group[i]=1;
  Group[7]=7;
  for (i=0;i<7;i++)
  {
    sint  j;
    for (j=0;j<s;j++) Full[i][j]=1;
    Full[i][128]=s;
    s *= 2;
  }
}

static inline
void UpdateRoot(uint * Freq)
{
  if (Freq[6]>MaxRootFreq)
  {
    uint i,Cum=0;
    for (i=0;i<6;i++)
      Cum +=(Freq[i]=(Freq[i]+1) >> 1);
    Freq[6]=Cum;
  }
  if (New[6]>MaxFreq)
  {
    uint i,Cum=0;
    for (i=0;i<6;i++)
      Cum +=(New[i]>>=1);
    New[6]=Cum;
  }  
}

static inline
void UpdateGroup(void)
{
  if (Group[7]>MaxGroupFreq)
  {
    uint i,Cum=0;
    for (i=0;i<7;i++)
      Cum +=(Group[i]=(Group[i]+1) >> 1);
    Group[7]=Cum;
  }
}

uint EnCodeMTF(uc * In, sint Size, uc * Out)
{
  TempBuf=Out;
  InitModel();
  sint  Ptr=0;

  while (Ptr<Size)
  {
    uint MTF   =(uc)In[Ptr++];
         Freq  = Root[Order];
    if (MTF==0)
    {
       uint  Count=2,Tmp=0,L=0;
       while ((Ptr<Size)&&((MTF=In[Ptr++])==0)) Count++;
       while (Count!=1)
       {
          Tmp = (Tmp << 1) + (Count & 1);
          Count >>= 1; L++;
       }
       while (L>0)
       {
         if (Tmp & 1)
           Encode((New[1]++)+Freq[1]++,New[0]+Freq[0],(New[6]++)+Freq[6]++);
         else
	   Encode((New[0]++)+Freq[0]++,0,(New[6]++)+Freq[6]++);
         EOFTest();
         UpdateRoot(Freq);
         Tmp >>= 1;L--;
       }
       if ((Ptr==Size)&&(MTF==0)) break;
    }
    if (MTF<4)
    {
      uint i,Cum=0;
      for (i=0;i<=MTF;i++) Cum += Freq[i]+New[i];
      Encode((New[MTF+1]++)+Freq[MTF+1]++,Cum,(New[6]++)+Freq[6]++);
      EOFTest();
      UpdateRoot(Freq);
      Order= (Order << 2)|(uc)(MTF-1);
      continue;
    }
    uint i,Cum=New[6]+Freq[6]-Freq[5]-New[5];
    Encode((New[5]++)+Freq[5]++,Cum,(New[6]++)+Freq[6]++);
	EOFTest();
    UpdateRoot(Freq);
    Order= (Order << 2)| 3;
    MTF -= 4;
    uint  Gr=0,S=2;
    while (MTF>=S) {MTF -= S;Gr++;S *= 2;}
    for (i=0,Cum=0;i<Gr;i++) Cum += Group[i];
    Encode(Group[Gr]++,Cum,Group[7]++);
    EOFTest();
    UpdateGroup();
    Freq=Full[Gr];
    for (i=0,Cum=0;i<MTF;i++) Cum += Freq[i];
    Encode(Freq[MTF]++,Cum,Freq[128]++);
    EOFTest();
    if (Freq[128]>81*S)
    {
      uint i,Cum=0;
      for (i=0;i<S;i++) Cum +=(Freq[i]=(Freq[i]+1) >> 1);
      Freq[128]=Cum;
    }
  }
  uint i,Cum=0;
  Freq  = Root[Order];
  for (i=0;i<5;i++) Cum += Freq[i]+New[i];
  Encode(Freq[5]+New[5],Cum,Freq[6]+New[6]);
  EOFTest();
  for (i=0,Cum=0;i<6;i++) Cum += Group[i];
  Encode(Group[6],Cum,Group[7]);
  EOFTest();
  Freq=Full[6];
  for (i=0,Cum=0;i<127;i++) Cum += Freq[i];
  Encode(Freq[127],Cum,Freq[128]);
  EOFTest();
  ShiftLow();
  ShiftLow();
  ShiftLow();
  ShiftLow();
  ShiftLow();
  return (TempBuf-Out);
}

uint DeCodeMTF(uc * In, uc * Out)
{
  TempBuf=In;
  InitModel();
  Code=InByte();Code <<= 8;
  Code=Code|InByte();Code <<= 8;
  Code=Code|InByte();Code <<= 8;
  Code=Code|InByte();Code <<= 8;
  Code=Code|InByte();
  while (1)
  {
    Freq  = Root[Order];
    uint  MTF=1;
    uint  Run=0;
    do {
      Run = (Run << 1) + MTF;
      uint  Fr = GetFreq(Freq[6]+New[6]);
      uint  Cum=0;
      MTF=  0;
      while (Fr>=Cum) {Cum += (Freq[MTF]+New[MTF]);MTF++;}
      MTF--; Cum -=(Freq[MTF]+New[MTF]);
      Decode((New[MTF]++)+Freq[MTF]++,Cum,(New[6]++)+Freq[6]++);
      UpdateRoot(Freq);
    } while (MTF <2);
    while (--Run) Out[OutSize++]=0;
    MTF--;
    Order= (Order << 2)|(uc)(MTF-1);
    if (MTF<4)
    {
      Out[OutSize++]=(uc)MTF;
      continue;
    }
    uint  Fr = GetFreq(Group[7]);
    uint  Cum=0,Gr=0,S=1,K=4;
    while (Fr>=Cum) {Cum += Group[Gr];Gr++;S *=2; K += S;}
    Gr--; Cum -=Group[Gr];K -= S;
    Decode(Group[Gr]++,Cum,Group[7]++);
    UpdateGroup();
    Freq=Full[Gr];
    Fr = GetFreq(Freq[128]);
    Cum=0;MTF=0;
    while (Fr>=Cum) {Cum += Freq[MTF];MTF++;}
    MTF--; Cum -=Freq[MTF];
    Decode(Freq[MTF]++,Cum,Freq[128]++);
    if (Freq[128]>81*S)
    {
      uint i,Cum=0;
      for (i=0;i<S;i++) Cum +=(Freq[i]=(Freq[i]+1) >> 1);
      Freq[128]=Cum;
    }
    if ((Gr==6)&&(MTF==127)) break;
    Out[OutSize++]=(uc)(K+MTF);
  }
  return OutSize;
}

#define WFC_MaxByte        256

#define WFC_Val0           131072
#define WFC_Val1           114688
#define WFC_Val2           7272
#define WFC_Val3           4240
#define WFC_Val4           2364
#define WFC_Val5           1263
#define WFC_Val6           649
#define WFC_Val7           320
#define WFC_Val8           153
#define WFC_Val9           70
#define WFC_Val10          31
#define WFC_Val11          14
#define WFC_Val12          8

#define WFC_Pos1           1
#define WFC_Pos2           2
#define WFC_Pos3           4
#define WFC_Pos4           8
#define WFC_Pos5           16
#define WFC_Pos6           32
#define WFC_Pos7           64
#define WFC_Pos8           128
#define WFC_Pos9           256
#define WFC_Pos10          512
#define WFC_Pos11          1024
#define WFC_Pos12          2048

#define WFC_Init()                                    \
  uc * TmpBuf=(uc *)malloc(Size);                     \
  uc   WFC_List[WFC_MaxByte];                         \
  uc   Char2Index[WFC_MaxByte];                       \
  sint CharWeight[WFC_MaxByte];                       \
  sint i,j;                                           \
  uc   c;                                             \
  sint W;                                             \
  for (i=0;i<WFC_MaxByte;i++)                         \
  {                                                   \
    WFC_List[i]=Char2Index[i]=i;                      \
    CharWeight[i]=0;                                  \
  }                                                   \

#define WFC_Finish()  free(TmpBuf);                   \

#define Update_Weight0(c)                             \
  CharWeight[c]+=WFC_Val0;                            \
  j=Char2Index[c];                                    \
  do {                                                \
    Char2Index[WFC_List[j]=WFC_List[j-1]]=j;          \
  } while (--j);                                      \
  WFC_List[0]=c;                                      \
  Char2Index[c]=0;                                    \

#define Update_Weight(c,Weight)                       \
  W=(CharWeight[c]-=Weight);                          \
  if ((j=Char2Index[c])<(WFC_MaxByte-1))              \
  {                                                   \
    while (CharWeight[WFC_List[j+1]]>W)               \
     {                                                \
       Char2Index[WFC_List[j]=WFC_List[j+1]]=j;       \
       if ((++j)==(WFC_MaxByte-1)) break;             \
     }                                                \
  WFC_List[j]=c;                                      \
  Char2Index[c]=j;                                    \
  }                                                   \

#define Update_Weight_Full(Weight,Pos)                \
  if (i>=Pos)                                         \
  {                                                   \
    c=TmpBuf[i-Pos];Update_Weight(c,Weight);          \
  }                                                   \

void WFC_Encode(uc * Input,sint Size)
{
  WFC_Init();
  for (i=0;(i<Size)&&(i<WFC_Pos12);i++)
  {
    c=TmpBuf[i]=Input[i];
    Input[i]=Char2Index[c];
    Update_Weight0(c);
    Update_Weight_Full(WFC_Val1,WFC_Pos1);
    Update_Weight_Full(WFC_Val2,WFC_Pos2);
    Update_Weight_Full(WFC_Val3,WFC_Pos3);
    Update_Weight_Full(WFC_Val4,WFC_Pos4);
    Update_Weight_Full(WFC_Val5,WFC_Pos5);
    Update_Weight_Full(WFC_Val6,WFC_Pos6);
    Update_Weight_Full(WFC_Val7,WFC_Pos7);
    Update_Weight_Full(WFC_Val8,WFC_Pos8);
    Update_Weight_Full(WFC_Val9,WFC_Pos9);
    Update_Weight_Full(WFC_Val10,WFC_Pos10);
    Update_Weight_Full(WFC_Val11,WFC_Pos11);
    Update_Weight_Full(WFC_Val12,WFC_Pos12);
  }
  for (;i<Size;i++)
  {
    uc  c=TmpBuf[i]=Input[i];
    Input[i]=Char2Index[c];
    Update_Weight0(c);
    c=TmpBuf[i-WFC_Pos1];  Update_Weight(c,WFC_Val1);
    c=TmpBuf[i-WFC_Pos2];  Update_Weight(c,WFC_Val2);
    c=TmpBuf[i-WFC_Pos3];  Update_Weight(c,WFC_Val3);
    c=TmpBuf[i-WFC_Pos4];  Update_Weight(c,WFC_Val4);
    c=TmpBuf[i-WFC_Pos5];  Update_Weight(c,WFC_Val5);
    c=TmpBuf[i-WFC_Pos6];  Update_Weight(c,WFC_Val6);
    c=TmpBuf[i-WFC_Pos7];  Update_Weight(c,WFC_Val7);
    c=TmpBuf[i-WFC_Pos8];  Update_Weight(c,WFC_Val8);
    c=TmpBuf[i-WFC_Pos9];  Update_Weight(c,WFC_Val9);
    c=TmpBuf[i-WFC_Pos10]; Update_Weight(c,WFC_Val10);
    c=TmpBuf[i-WFC_Pos11]; Update_Weight(c,WFC_Val11);
    c=TmpBuf[i-WFC_Pos12]; Update_Weight(c,WFC_Val12);
  }
  WFC_Finish();
}

void WFC_Decode(uc * Input, sint Size)
{
  WFC_Init();
  for (i=0;(i<Size)&&(i<WFC_Pos12);i++)
  {
    c=WFC_List[Input[i]];TmpBuf[i]=Input[i]=c;
    Update_Weight0(c);
    Update_Weight_Full(WFC_Val1,WFC_Pos1);
    Update_Weight_Full(WFC_Val2,WFC_Pos2);
    Update_Weight_Full(WFC_Val3,WFC_Pos3);
    Update_Weight_Full(WFC_Val4,WFC_Pos4);
    Update_Weight_Full(WFC_Val5,WFC_Pos5);
    Update_Weight_Full(WFC_Val6,WFC_Pos6);
    Update_Weight_Full(WFC_Val7,WFC_Pos7);
    Update_Weight_Full(WFC_Val8,WFC_Pos8);
    Update_Weight_Full(WFC_Val9,WFC_Pos9);
    Update_Weight_Full(WFC_Val10,WFC_Pos10);
    Update_Weight_Full(WFC_Val11,WFC_Pos11);
    Update_Weight_Full(WFC_Val12,WFC_Pos12);
  }
  for (;i<Size;i++)
  {
    uc  c=WFC_List[Input[i]];TmpBuf[i]=Input[i]=c;
    Update_Weight0(c);
    c=TmpBuf[i-WFC_Pos1];  Update_Weight(c,WFC_Val1);
    c=TmpBuf[i-WFC_Pos2];  Update_Weight(c,WFC_Val2);
    c=TmpBuf[i-WFC_Pos3];  Update_Weight(c,WFC_Val3);
    c=TmpBuf[i-WFC_Pos4];  Update_Weight(c,WFC_Val4);
    c=TmpBuf[i-WFC_Pos5];  Update_Weight(c,WFC_Val5);
    c=TmpBuf[i-WFC_Pos6];  Update_Weight(c,WFC_Val6);
    c=TmpBuf[i-WFC_Pos7];  Update_Weight(c,WFC_Val7);
    c=TmpBuf[i-WFC_Pos8];  Update_Weight(c,WFC_Val8);
    c=TmpBuf[i-WFC_Pos9];  Update_Weight(c,WFC_Val9);
    c=TmpBuf[i-WFC_Pos10]; Update_Weight(c,WFC_Val10);
    c=TmpBuf[i-WFC_Pos11]; Update_Weight(c,WFC_Val11);
    c=TmpBuf[i-WFC_Pos12]; Update_Weight(c,WFC_Val12);
  }  
  WFC_Finish();  
}

void GRZip_AWFC_Encode(uc * Input, sint Size)
{
  uc   * TmpBuf=(uc *)malloc(Size);
  sint i,TmpBufSize=0;
  uc   Pred=0;
  for (i=0;i<Size;i++)
    if (Input[i]!=Pred) Pred=TmpBuf[TmpBufSize++]=Input[i];
  WFC_Encode(TmpBuf,TmpBufSize);
  Pred=0; TmpBufSize=0;
  for (i=0;i<Size;i++)
    if (Input[i]!=Pred)
    {
      Pred=Input[i];
      Input[i]=TmpBuf[TmpBufSize++];
    }
    else
      Input[i]=0;
  free(TmpBuf);
}

void GRZip_AWFC_Decode(uc * Input,sint Size)
{
  uc   * TmpBuf=(uc *)malloc(Size);
  uc   Pred=0;
  sint i,TmpBufSize=0;
  for (i=0;i<Size;i++)
    if (Input[i]) TmpBuf[TmpBufSize++]=Input[i];
  WFC_Decode(TmpBuf,TmpBufSize);
  TmpBufSize=0;
  for (i=0;i<Size;i++)
    if (Input[i]==0) Input[i]=Pred;
    else
      Pred=Input[i]=TmpBuf[TmpBufSize++];
  free(TmpBuf);
}

#define MTF_MaxByte        256

#define MTF_Init()                                    \
  uc MTF_List[256];                                   \
  sint i;                                             \
  for (i=0;i<MTF_MaxByte;i++) MTF_List[i]=i;          \
  
void GRZip_MTF_Encode(uc * Input, sint Size)
{
  uc Flag=0;
  MTF_Init();
  for (i=0;i<Size;i++)
  {
    uc Pos=0,c=Input[i];
    while (MTF_List[Pos]!=c) Pos++;
    Input[i]=Pos;
    if (Pos>1)
    {
      for (;Pos>1;--Pos) MTF_List[Pos]=MTF_List[Pos-1];
      MTF_List[1]=c;
      Pos=1;
    } else if ((Flag)&&(Pos==1))
    {
      MTF_List[1]=MTF_List[0];
      MTF_List[0]=c;
    }
    Flag=Pos;
  }
}

void GRZip_MTF_Decode(uc * Input,sint Size)
{
  uc Flag=0;
  MTF_Init();
  for (i=0;i<Size;i++)
  {
    uc Pos=Input[i],c=Input[i]=MTF_List[Pos];
    if (Pos>1)
    {
      for (;Pos>1;--Pos) MTF_List[Pos]=MTF_List[Pos-1];
      MTF_List[1]=c;
      Pos=1;
    } else if ((Flag)&&(Pos==1))
    {
      MTF_List[1]=MTF_List[0];
      MTF_List[0]=c;
    }
    Flag=Pos;
  }
}

#undef MTF_MaxByte 
#undef MTF_Init

#undef WFC_MaxByte

#undef WFC_Init
#undef WFC_Finish
#undef Update_Weight
#undef Update_Weight0
#undef Update_Weight_Full

#undef WFC_Val0
#undef WFC_Val1
#undef WFC_Val2
#undef WFC_Val3
#undef WFC_Val4
#undef WFC_Val5
#undef WFC_Val6
#undef WFC_Val7
#undef WFC_Val8
#undef WFC_Val9
#undef WFC_Val10
#undef WFC_Val11
#undef WFC_Val12

#undef WFC_Pos1
#undef WFC_Pos2
#undef WFC_Pos3
#undef WFC_Pos4
#undef WFC_Pos5
#undef WFC_Pos6
#undef WFC_Pos7
#undef WFC_Pos8
#undef WFC_Pos9
#undef WFC_Pos10
#undef WFC_Pos11
#undef WFC_Pos12
